/*
 * DAVIDS lets you find and view duplicates in your Spotify playlists.
 * Copyright (C) 2016  Gabriel Augendre <gabriel@augendre.info>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

'use strict';
var React = require('react');
var ReactBootstrap = require('react-bootstrap');

var PlaylistBox = React.createClass({
    getInitialState: function () {
        return {
            currentId: null
        };
    },
    clickOnItem: function (id, uid, event) {
        event.preventDefault();
        this.setState({currentId: id});
        this.props.handleClick(id, uid);
    },
    render: function () {
        var ListGroup = ReactBootstrap.ListGroup,
            ListGroupItem = ReactBootstrap.ListGroupItem;
        var currentId = this.state.currentId;

        var playlists = <p>No playlist found.</p>;
        if (this.props.playlists) {
            playlists = this.props.playlists.map(function (pl) {
                var id = pl.id;
                return (
                    <ListGroupItem href="#" onClick={this.clickOnItem.bind(this, id, pl.owner.id)} active={currentId == id} key={id}>{pl.name}</ListGroupItem>
                );
            }, this);
        }

        return (
            <ListGroup>
                {playlists}
            </ListGroup>
        );
    }
});

module.exports = PlaylistBox;
